<?php
 /**
  * Live Ratings Implementation
  * Base Class
  * @autor jose @ www.pia-clan.com
  * @date Agoust, 2006
  * @update Agoust 16, 2007
  **/

class LiveRatings
{
	var $players;
	var $avgInfo;
	var $sortOrderDesc;
	var $sortKey;
	var $sortType;
	var $filePlayer;
	
	/**
	 * Constructor
	 * @param string $sortKey Order Key
	 * @param string $sortOrder Order of the sorting
	 **/
	function LiveRatings ($sortKey = "rating", $sortOrder = "DESC")
	{
		$this->players = array ();
		$this->avgInfo = array (
            'count' => 0,
            'rating' => 0,
            'wins' => 0,
            'losses' => 0,
            'inc' => 0,
            'streak' => 0
        );

		$ordersKeys = array ('rating', 'nick', 'wins', 'losses', 'games', 'streak', 'winper', 'inc');

		(!in_array ($sortKey, $ordersKeys)) ? $this->sortKey = 'rating' : $this->sortKey = $sortKey;
		
		$this->sortOrderDesc = ( $sortOrder == 'ASC' ) ? 1 : -1;
	}
	/**
	 * Return the Average Info
	 * @return array $AvgInfo
	 **/
	function getAVGInfo ()
	{
        if (!isset ($this->avgInfo['games']))
        {
            $this->avgInfo['games'] = 0;
            $this->avgInfo['winper'] = 0;
            $this->avgInfo['rating'] = 1600;
        }
		return $this->avgInfo;
	}
	
	/**
	 * Read Players from one txt file
	 * @param string $strFile File that contents the players Nicksnames, and Country info
	 **/
	function readPlayersFromFile ($strFile)
	{
		if (file_exists ($strFile))
		{
			$this->strFile = $strFile;
			$arrayElements = file ($strFile);
			for ($i = 0; $i < count ($arrayElements); $i++)
			{
				$element = trim ($arrayElements[$i]);
				if ($element != "")
				{
					$element = split (',', $element);
					if (count ($element) >= 3)
					{
						$this->addPlayers ($element[0], $element[1], $element[2], $element[3], $element[4], $element[5]);
					}
				}
			}
		}
		else
		{
			die ('FILE of players "' . $strFile . '" doesn\'t exist.');
		}
	}
         
     /**
     * 0 => LKC_Fenix,1 => 9999999,2-Jhon,3-Rank,4-Pais,5-PaisImg
     * 
     * 
     */
	/**
	 * Add Player used by readPlayersFromFile ()
     * @param string $strNick Nick of the player
     * TODO
	 **/
	function addPlayers ($pNick, $pId, $pName, $pRank, $pCountry, $pCountryImageFile)
	{
		$this->players[] = new CPlayer ($pNick, $pId, $pName, $pRank, $pCountry, $pCountryImageFile);
	}
	/**
	 * Check if the current file is old
	 * @param string $file File to be checked
	 * @abstract
	 **/
	function isOldCache ($file)
	{

	}
	/**
	 * Write the Info of the players and the AVG info in one cache file
	 * @param string $file File where will be saved the info.
	 **/
	function writeCache ($file)
	{
		$fp = @fopen ($file, "w");
		$archivo = "<?
					\$playersInfo = '" . addslashes (serialize ($this->players)) . "';
					\$playersInfo = unserialize (stripslashes (\$playersInfo));
					\$avgInfo = '" . addslashes (serialize ($this->avgInfo)) . "';
					\$avgInfo = unserialize (stripslashes (\$avgInfo));
					?>";
		@fwrite ($fp, $archivo);
		@fclose ($fp);
	}
	/**
	 * Read information of the Players (nick, rating, range, and games)
	 * to calculate the rating diference (DIF)
	 * @param string $file File where the Info are saved
	 * @return array $Players players info saved
	 **/

	/**
	 * Read a cache Info Players and AVG info
	 * @param string $file File where the data are saved
	 **/
	function readCache ($file)
	{
		require ($file);
		$this->players = $playersInfo;
		$this->avgInfo = $avgInfo;
		$this->sortPlayers ();
	}
	/**
	 * Get ratings from the Game Patform
	 * @abstract
	 **/
	function getRatings ()
	{
	}
	/**
	 * Proccess the Result of the getRstings ()
	 * @abstract
	 **/
	function processResult ()
	{
	}

	/**
	 * Sort Method of the Players
	 * @param object $pElementA first player to be compared
 	 * @param object $pElementB second player to be compared
	 **/
	function sortMethod ($pElementA, $pElementB)
	{
		if ($this->sortTypeNumeric)
		{
			if ($pElementA->parsedData[$this->sortKey] == $pElementB->parsedData[$this->sortKey]) return 0;
			return ($pElementA->parsedData[$this->sortKey] < $pElementB->parsedData[$this->sortKey]) ? ( -1 * $this->sortOrderDesc ) : ( 1 * $this->sortOrderDesc);
		}
		else
		{
			return (strcasecmp ($pElementA->parsedData[$this->sortKey], $pElementB->parsedData[$this->sortKey]) * $this->sortOrderDesc);
		}		
	}
	/**
	 * Sort Players switcher
	 **/
	function sortPlayers ()
	{
		($this->sortKey == 'nick') ? $this->sortTypeNumeric = FALSE : $this->sortTypeNumeric = TRUE;
		usort ($this->players, array ($this, "sortMethod"));
	}
	/**
	 * Save the top player info for the portals
	 * @param string $file File where the data will be saved
	 **/
	function saveTopRank ($file)
	{
		if ($this->sortKey == 'rating' && $this->sortOrderDesc == -1)
		{
			$resort = FALSE;
		}
		else
		{
			$resort = TRUE;
			$sortKey = $this->sortKey;
			$sortOrder = $this->sortOrderDesc;
			
			$this->sortKey = 'rating';
			$this->sortOrderDesc = -1;
		}
		
		$this->sortPlayers ();
		
		$fp = @fopen ($file, "w");
		if ($fp)
		{
			for ($i = 0; $i < TOP_RANK && $i < $this->playersCount(); $i++)
			{
				$str = $this->players[$i]->mNickName . ",";
				$str .= $this->players[$i]->mCountry . ",";
				$str .= $this->players[$i]->mCountryImageFile . ",";
				$str .= $this->players[$i]->parsedData['rating'] . ",";
				$str .= $this->players[$i]->parsedData['id'] . "\r\n";
				@fwrite($fp, $str);
			}
		}
		@fclose ($fp);
		
		if ($resort)
		{
			$this->sortKey = $sortKey;
			$this->sortOrderDesc = $sortOrder;
		}
	}
	/**
	 * Return the Player at the Index 
	 * @param int $index index of the player to be retorned
	 * @return object $this->players[$index]
	 **/
	function getPlayerAt ($index)
	{
		return $this->players[$index];
	}
	/**
	 * Return the Players cuantity added 
	 * @return int $count 
	 **/
	function playersCount ()
	{
		return count ($this->players);
	}
	/**
	 * Funcion parser of the Rating date
	 * @abstract
	 * @return array $parsedData Array with the parsed data elements
	 */
	function parseData ($data)
	{

	}
}


/**
 * Voobly Ratings Implement
 **/
class VooblyLiveRatings extends LiveRatings
{
    var $mLadderId;

    /**
     * Constructor
     **/
    function VooblyLiveRatings ($sortKey, $sortOrder)
	{
		LiveRatings::LiveRatings ($sortKey, $sortOrder);
        $this->mLadderId = LADDER_ID;
    }
    function setLadderId ($id)
    {
        $this->mLadderId = $id;
    }
    function getLadderId ()
    {
        return $this->mLadderId;
    }

	function isOldCache ($file, $checkTime = TRUE)
	{
		if (file_exists ($file))
		{
			/**
			 * 21600 seconds of cache (6 hours)
			 */
			if (((filemtime ($file) + 21600) < time ()) && $checkTime || @filemtime ($this->strFile) > filemtime ($file))
			{
				return TRUE;
			}
			else
			{
				return FALSE;
			}
		}
		else
		{
			return TRUE;
		}
	}
    function cleanUserName ($pNick, &$pTag)
    {
        $pTag = '';
        if ($pNick[0] == '[')
        {
            $end = strpos ($pNick, ']') + 1;
            $pTag = substr ($pNick, 0, $end);
            $pNick = substr ($pNick, $end);
        }
        return $pNick;
    }
    function getRatings ()
    {
		if (!$this->isOldCache (RATINGS_VOOBLY_CACHE))
		{
			$this->readCache (RATINGS_VOOBLY_CACHE);
			return;
		}
		
        $sockets = array ();
        $buffers = array ();

        $host = "www.voobly.com";
        $headersRatings = "GET /api/ladder/%d?key=%s&uidlist=%s HTTP/1.0\r\nHost: %s\r\n\r\n";

        
        $totalPlayers = $this->playersCount();
 		$playerList = array ();
                
        for ($i = 0; $i < $totalPlayers; $i++)
        {
            if ($this->players[$i]->mId == 0) continue;
               
            $playerList[] = $this->players[$i]->mId;
        }
        
        if (!empty ($playerList))
        {
            $playerList = implode (',', $playerList);
            $strHeaders = sprintf ($headersRatings, $this->getLadderId(), VOOBLY_KEY, $playerList, $host);
            $socket = @fsockopen($host, 80, $errNo, $errStr, 30);
            if ($socket)
            {
				stream_set_timeout($socket, 30);
                @socket_set_blocking ($socket, FALSE);
                @fwrite ($socket, $strHeaders);
                
                $buffers = '';
                $ready = FALSE;
                while (!$ready)
                {
                    $ready = TRUE;
                    if ($socket && !feof($socket))
                    {
                        $buffers .= fgets ($socket, 8192);
                        $ready = FALSE;
                    }
                }
                @fclose ($socket);

                //$this->parseRatings ();
                
                $success = $this->processResult ($buffers);    
                
                if ($success)
                {
                    $this->saveTopRank (TOP_RANK_VOOBLY);
                    $this->sortPlayers ();
                    $this->writeCache (RATINGS_VOOBLY_CACHE);            
                }
                else
                {
                    if (file_exists (TOP_RANK_VOOBLY))
                    {
                        $this->readCache (RATINGS_VOOBLY_CACHE);
                        /*
                        if ($this->isOldCache (RATINGS_VOOBLY_CACHE, FALSE))
                        {
                            $this->saveTopRank (TOP_RANK_VOOBLY);
                            $this->sortPlayers ();
                            $this->writeCache (RATINGS_VOOBLY_CACHE);
                        }
                        else
                        {
                            $this->readCache (RATINGS_VOOBLY_CACHE);
                        }*/
                    }
                    else
                    {
                        $this->saveTopRank (TOP_RANK_VOOBLY);
                        $this->sortPlayers ();
                        $this->writeCache (RATINGS_VOOBLY_CACHE);
                    }
                }
            }
            else
            {
                    $this->saveTopRank (TOP_RANK_VOOBLY);
                    $this->sortPlayers ();
                    $this->writeCache (RATINGS_VOOBLY_CACHE);
            }
        }
    }
     /**
     * processResult implement
     * @see LiveRatings::processResult ()
     **/
	function processResult ($buffers)
	{
        $totalPlayers = $this->playersCount();
		$returnFound = TRUE;
		
        $pos = strpos ($buffers, 'rank');
        if ($pos > 0)
        {
            $buffers = substr ($buffers, $pos);
            $partsPlayers = split ("\n", $buffers);
            $partsCount = count ($partsPlayers);
            for ($i = 1; $i <= $partsCount; $i++)
            {
                $parts = split (",", $partsPlayers[$i]);
                if (count ($parts) > 6)
                {
                    $parsedData = array (
                        'rank' => intval ($parts[0]),
                        'id' => intval ($parts[1]),
                        'nick' => $parts[2],
                        'rating' => intval ($parts[3]),
                        'games' => intval ($parts[4]) + intval ($parts[5]),
                        'winper' =>  sprintf ("%.2f", intval ($parts[4]) / (intval ($parts[4]) + intval ($parts[5])) * 100),
                        'wins' => intval ($parts[4]),
                        'losses' => intval ($parts[5]),
                        'inc' => 0,
                        'streak' => intval ($parts[6])
                    );
                    
                    for ($j = 0; $j < $totalPlayers; $j++)
                    {
                        if ($this->players[$j]->mId == $parsedData['id'])
                        {
                            $this->players[$j]->setParsedData ($parsedData);
                            break;
                        }
                    }
                }
            }
        }
        else
        {
            $returnFound = FALSE;
        }
  
		for ($k = 0; $k < $totalPlayers; $k++ )
		{
			if ($this->players[$k]->parsedData['games'] != 0)
			{
				$this->avgInfo['count'] ++;
				$this->avgInfo['rating'] += $this->players[$k]->parsedData['rating'];
				$this->avgInfo['wins'] += $this->players[$k]->parsedData['wins'];
				$this->avgInfo['losses'] += $this->players[$k]->parsedData['losses'];
				$this->avgInfo['inc'] += intval ($this->players[$k]->parsedData['inc']);
				$this->avgInfo['streak'] += intval ($this->players[$k]->parsedData['streak']);
			}
 		}
		
		$this->avgInfo['games'] = $this->avgInfo['wins'] + $this->avgInfo['losses'];

		foreach ($this->avgInfo as $key => $value)
		{
			if ($key == 'count') continue;
			
			$this->avgInfo[$key] = sprintf ("%.2f", @($this->avgInfo[$key]/$this->avgInfo['count']));
		}
		$this->avgInfo['winper'] = sprintf ("%.2f", @($this->avgInfo['wins'] / ($this->avgInfo['wins'] + $this->avgInfo['losses']) * 100));
		
		return $returnFound;
	}
}



 /**
  * CPlayer 
  * Base Class of the Player
  **/
  
class CPlayer
{
	var $mNickName;
	var $mCountry;
	var $mCountryImageFile;
	var $parsedData;
	var $mId;

	var $mNick;
	var $mTag;
    
	/**
	 * Constructor
	 * @param string $strNick Nick of the player
     * asdf
	 **/
	function CPlayer ($pNick, $pId, $pName, $pRank, $pCountry, $pCountryImageFile)
	{
		$this->mNickName = $pNick;
        $this->mId = $pId;
        $this->mRank = $pRank;
        $this->mName = $pName;
		$this->mCountry = $pCountry;
		$this->mCountryImageFile = $pCountryImageFile;
		
		$this->parsedData = array (
			'rank' => 0,
			'id' => $pId,
			'nick' => $this->mNickName,
			'tag' => '',
			'rating' => 1600,
			'games' => 0,
			'winper' => 0,
			'wins' => 0,
			'losses' => 0,
			'inc' => 0,
			'streak' => 0
		);
	}
	/**
	 * Set the Rating info of Parsed data
	 * @param array $data Rating info to be saved
	 **/ 
	 
	function setParsedData ($data)
	{
		if ($data['games'] != 0)
		{
			$this->parsedData = $data;
		}
	}
}
?>